question = {}

addhook("minute", "random_math_question")
function random_math_question()
  local simple = math.random(3) == 1
  local num1 = math.random(simple and 10 or 100)
  local num2 = math.random(simple and 10 or 100)
  while num2 == 0 or num1 % num2 ~= 0 do
    num1 = math.random(simple and 10 or 100)
    num2 = math.random(simple and 10 or 100)
  end
  local num3 = simple and 0 or math.random(100)
  while num3 ~= 0 and (num1 + num2 + num3) % num3 ~= 0 do
    num3 = math.random(100)
  end
  local operations = {
    [1] = function() return num1 + num2 end,
    [2] = function() return num1 - num2 end,
    [3] = function() return num1 * num2 end,
    [4] = function() return num1 / num2 end,
  }
  local operator_symbols = {
    [1] = "+",
    [2] = "-",
    [3] = "*",
    [4] = "/",
  }
  local operator1 = math.random(#operations)
  local operator2 = simple and 0 or math.random(2)
  local operation = operations[operator1]
  local operator_symbol1 = operator_symbols[operator1]
  local operator_symbol2 = simple and "" or (operator2 == 1 and "+" or "-")
  local question_text = "What is " .. num1 .. " " .. operator_symbol1 .. " " .. num2
  if not simple then
    question_text = question_text .. " " .. operator_symbol2 .. " " .. num3
  end
  question_text = question_text .. "?"
  question = {
    answer = operation() + (operator2 == 1 and num3 or -num3),
    text = question_text,
    answered = false,
    winner = -1
  }
  msg("[MATH QUIZ] " .. question.text)
end

addhook("say", "detect_answers")
function detect_answers(id, text)
  if question.answered then
    if tonumber(text) == question.answer then
      msg2(id,"Someone already answered the question.")
    end
    return
  end
  local playerAnswer = tonumber(text)
  if playerAnswer and playerAnswer == question.answer then
    question.answered = true
    question.winner = id
    parse("setmoney " .. id .. " "..(player(id,"money")+3000).."")
    msg(""..player(id,"name").." answered correctly!@C")
  end
end